//
//  DeVercruesseProcessManager.h
//
//  Created by Frank Vercruesse on Wed Apr 04 2001.
//  Copyright (c) 2001 Frank Vercruesse.
//
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.

#import "DeVercruesseProcess.h"
#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>


#define ProcessMgr [DeVercruesseProcessManager defaultManager]


@interface DeVercruesseProcessManager : NSObject
{
    NSMutableSet	*processes;
    NSDictionary	*rules;
}

+ (id)defaultManager;

- (DeVercruesseProcess*)currentProcess;
- (DeVercruesseProcess*)frontProcess;
- (DeVercruesseProcess*)nextToFrontProcess;
- (DeVercruesseProcess*)anyNoBGOnlyProcess;

- (NSArray*)processes;
- (void)update;

- (void)showAll;
- (void)hideOthers;
- (void)hideOthers:(BOOL)ignoreRules;
- (void)hideFront;

- (void)setFront:(DeVercruesseProcess*)process;

- (void)setRules:(NSArray*)r;
- (BOOL)anyRulesForProcess:(DeVercruesseProcess*)process;
- (BOOL)checkRule:(NSString*)ruleKey withProcess:(DeVercruesseProcess*)process;
- (NSSet*)processIdentifiersForRule:(NSString*)ruleKey;
- (int)optionsForRule:(NSString*)ruleKey withProcess:(DeVercruesseProcess*)process;

@end
